local myname="ZifnabsTargets"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={targets=Me} else ZifnabsMod.targets=Me end
local mod
local L
local db

local MINDISTANCE=0.3				-- only use an additional position slot if distance larger than 0.3 to all existing positions
local MAXIMUMPOSITIONS=10			-- keep max. 10 positions per target in database
local MINTIMEDELTATOKEEP=30*60		-- keep players in db that have been see by the same char at least over a range of 30 minutes
local AGE2DELETEONCE=14*24*60*60	-- delete once met players after 14 days
local PLAYERNAME=UnitName("player").." "..GetRealmName()
local FACTION=UnitFactionGroup("player")
local SKULL="|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:18:18|t" --"HH" -- {rt8} geht da leider nicht :(

local widget={}
local searchresult=nil
local lastcursor=nil
local koswarn={}

local config={}

-- Slash Commands
SLASH_ZIFNABSTARGETS1 = "/zt"
SlashCmdList["ZIFNABSTARGETS"]=function (parm) Me:RunSearch(parm) end

-- TODO handling of PVP kills by opponent's faction player

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	dbpc=fwinfo.dbpc
	if not db.targets then db.targets={list={},settarget={}} end
	if db.targets.active==nil then db.targets.active=true end	-- Neu nach r191203a
	if db.targets.kos==nil then db.targets.kos=true end			-- Neu nach r191203a
	if db.targets.settarget[PLAYERNAME] then 					-- Neu nach r200526b
		dbpc.name=db.targets.settarget[PLAYERNAME]
		db.targets.settarget[PLAYERNAME]=nil
	end
	
	for name,info in pairs(db.targets.list) do
		if info.player and not info.classified and not info.pvpkills then
			local keep=false
			local seen={}
			for pos,whowhen in pairs(info.seen) do
				for player,time in pairs(whowhen) do
					seen['LAST']=time
					if not seen[player] then seen[player]={first=time,last=time}
					else 
						seen[player].last=time 
						if time-seen[player].first>MINTIMEDELTATOKEEP then keep=true end
					end
				end
			end
			if not keep and time()-seen['LAST']>AGE2DELETEONCE then 
				db.targets.list[name]=nil
				mod.f:PrintR(L.msg.targetdeleted,{name=name})
			end
		end
	end
	widget.frame=mod.ui:newFrame(myname.."_Info",400,20,UIParent,"TOP","TOP",0,0,{transparent=true})
	widget.info=mod.ui:addText(myname.."_Info_Text",400,60,widget.frame,"TOPLEFT","TOPLEFT",4,-4,11,"LEFT","TOP")
	widget.searchbutton=mod.ui:newButton(myname.."_Search_Button",20,16,widget.frame,"TOPLEFT","TOPRIGHT",0,0,{click=Me.ButtonSearch,text="?",tt=L.msg.ttsearch})
	widget.searchinput=mod.ui:newEditBox(myname.."_Search_Input",400,20,widget.frame,"TOPLEFT","TOPLEFT",0,0,{onkey=Me.InputSearch,hide=true})
	widget.locatebutton=mod.ui:newButton(myname.."_Locate_Button",20,16,widget.frame,"TOPLEFT","TOPRIGHT",0,-16,{click=Me.ButtonLocate,text="*",hide=true,tt=L.msg.ttlocate})
	widget.commentbutton=mod.ui:newButton(myname.."_Comment_Button",20,16,widget.frame,"TOPLEFT","TOPRIGHT",-16,0,{click=Me.ButtonComment,text="@",hide=true,tt=L.msg.ttcomment})
	widget.palbutton=mod.ui:newButton(myname.."_Pal_Button",32,16,widget.frame,"TOPLEFT","TOPRIGHT",-32,0,{click=Me.ButtonPal,text="T",hide=true})
	widget.searchup=mod.ui:newButton(myname.."_Search_Up",20,16,widget.frame,"TOPLEFT","TOPRIGHT",-16,-16,{click=Me.ShowSearch,text="^",hide=true,tt=L.msg.ttsearchup})
	widget.searchdown=mod.ui:newButton(myname.."_Search_Down",20,16,widget.frame,"TOPLEFT","TOPRIGHT",-16,-32,{click=Me.ShowSearch,text="v",hide=true,tt=L.msg.ttsearchdown})
end
function Me:PostInit()
	Me:Activate(db.targets.active)
	Me:SetTarget(dbpc.name,"init") 
	widget.info:SetText(L.msg.notargetyet)
end

-- --------------------------------------------------------------------------------------
-- ACTIVATE
-- --------------------------------------------------------------------------------------
function Me:Activate(set)
	if set then
		mod.core:Register4Event("ONUPDATE","targets",Me.OnUpdate)
		mod.core:Register4Event("PLAYER_TARGET_CHANGED","targets",Me.PLAYER_TARGET_CHANGED)
		mod.loc:Register4Map("targets",Me.MapChanged)
		widget.frame:Show()
	else
		mod.core:DeRegister4Event("ONUPDATE","targets",Me.OnUpdate)
		mod.core:DeRegister4Event("PLAYER_TARGET_CHANGED","targets",Me.PLAYER_TARGET_CHANGED)
		mod.loc:DeRegister4Map("targets",Me.MapChanged)
		widget.frame:Hide()
	end
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	if (widget.info.showtime or 0)>0 and not widget.info.fixed then
		widget.info.showtime=widget.info.showtime-elapsed
		if widget.info.showtime<=0 then 
			widget.info:SetText("") 
			widget.locatebutton:Hide()
			widget.commentbutton:Hide()
			widget.palbutton:Hide()
		end
	end
	local cursor=getglobal("GameTooltipTextLeft1"):GetText()
	if cursor and cursor~=lastcursor then
		local cursor2=getglobal("GameTooltipTextLeft2"):GetText() or ""
		if string.find(cursor2,L.word.ttPlayer) and db.targets.list[cursor] then
			local kos=db.targets.list[cursor].kos
			if kos and kos[FACTION]=="KoS" then Me:KoS(cursor) end
		end
		lastcursor=cursor
	end
end

-- --------------------------------------------------------------------------------------
-- PLAYER TARGET CHANGED
-- --------------------------------------------------------------------------------------
function Me:PLAYER_TARGET_CHANGED()
	if not widget.info.fixed then widget.info.showtime=5 end
	if UnitExists("target")  then
		local name=UnitName("target")
		local lclass,class=UnitClass("target")
		local player=UnitIsPlayer("target")
		local sex=UnitSex("target")
		local faction=UnitFactionGroup("target")
		local family=UnitCreatureFamily("target") or UnitCreatureType("target")
		local lrace,race=UnitRace("target")
		local level=UnitLevel("target")
		local rarity=UnitClassification("target")
		if rarity=="normal" or rarity=="trivial" or rarity=="minus" then rarity=nil end
		if name~=UnitName("player") and (not UnitExists("pet") or UnitName("pet")~=name) and (race or not UnitPlayerControlled("target"))then 
			local save={seen={},classified=nil,pvpkills=nil,comment=nil}
			local entry=db.targets.list[name]
			if db.targets.list[name] then 
				save={lvl=entry.lvl,maxlvl=entry.maxlvl,kos=entry.kos,seen=entry.seen,classified=entry.classified,comment=entry.comment} 
			end
			local x,y,zone,mypos,znr=mod.loc:GetLoc()
			local usepos=nil
			local poscount=0
			local search={distance=999999,oldest=time(),oldestpos=nil,newest=0}
			for pos,whowhen in pairs(save.seen) do
				local pdistance=mod.loc:Distance(mypos,pos)
				poscount=poscount+1
				if pdistance<search.distance then 
					if pdistance<MINDISTANCE then usepos=pos end
					search.distance=pdistance
				end
				local last=0
				for playerchar,timeseen in pairs(whowhen) do 
					last=math.max(last,timeseen)
				end
				search.newest=math.max(search.newest,last)
				if last<search.oldest then
					search.oldest=last
					search.oldestpos=pos
				end
			end
			if not usepos then 
				save.seen[mypos]={}
				usepos=mypos
				if poscount>MAXIMUMPOSITIONS then save.seen[search.oldestpos]=nil end
				if name==dbpc.name then
					Me:SetTarget(name,"keep")
				end
			end
			save.seen[usepos][PLAYERNAME]=time()
			local guild=GetGuildInfo("target")
			-- TODO nächste Zeile nur, wenn Target in "Reichweite"
			if not guild and db.targets.list[name] then guild=db.targets.list[name].guild end
			if not player or time()-search.newest>300 or search.distance>1 then
				local maxlvl=save.maxlvl or level
				local lvl=save.lvl or level
				if lvl==-1 and level>0 then lvl=level end
				if maxlvl==-1 and level>0 then maxlvl=level end
				if level>0 then
					lvl=min(level,lvl)
					maxlvl=max(level,maxlvl)
				end
				db.targets.list[name]={
					sex=sex,class=class,player=player,faction=faction,guild=guild,
					family=family,race=race,lvl=lvl,maxlvl=maxlvl,rare=rarity,seen=save.seen,
					classified=save.classified,pvpkills=save.pvpkills,comment=save.comment
				}
			end
			if not widget.info.fixed then Me:ShowInfo(name,"target") end
		end
		local entry=db.targets.list[name]
		if entry and entry.kos and entry.kos[FACTION]=="KoS" then Me:KoS(name) end
	end
end

-- --------------------------------------------------------------------------------------
-- GET ENTRY (for external existance check)
-- --------------------------------------------------------------------------------------
function Me:Seen(name) return db.targets.list[name] end
function Me:KoS(name) 
	if db.targets.kos and (not koswarn[name] or time()-koswarn[name]>60) then
		mod.hud:write(mod.f:Repl(L.msg.kos,{name=name}),"KoS.mp3") 
		koswarn[name]=time()
	end
end

-- --------------------------------------------------------------------------------------
-- SHOW SEARCH
-- --------------------------------------------------------------------------------------
function Me:ShowSearch(nr,parse) 
	if parse and parse[#parse]=="Up" then
		nr=math.max(1,searchresult.show-1)
	elseif parse and parse[#parse]=="Down" then 
		nr=math.min(searchresult.max,searchresult.show+1) 
	end
	widget.info.fixed=true
	widget.searchbutton:SetText("X")
	widget.searchbutton.tooltipText=L.word.abort
	if nr>1 then widget.searchup:Show() else widget.searchup:Hide() end
	if nr<searchresult.max then widget.searchdown:Show() else widget.searchdown:Hide() end
	searchresult.show=nr
	Me:ShowInfo(searchresult.name[searchresult.sort[nr]],nil,nr,searchresult.max) 
end

-- --------------------------------------------------------------------------------------
-- SHOW INFO
-- --------------------------------------------------------------------------------------
function Me:ShowInfo(name,target,nr,of)
	local info=db.targets.list[name]
	local met={[PLAYERNAME]={first={time=time()+1},last={time=0}},["others"]={first={time=time()+1},last={time=0}}}
	for pos,whowhen in pairs(info.seen) do
		for playername,timeseen in pairs(whowhen) do
			local realname=playername
			if playername~=PLAYERNAME then playername="others" end
			if timeseen<met[playername].first.time then met[playername].first={time=timeseen,pos=pos,who=realname} end
			if timeseen>met[playername].last.time then met[playername].last={time=timeseen,pos=pos,who=realname} end
		end
	end
	local minlvl=info.lvl or "??"
	local maxlvl=info.maxlvl or info.lvl or "??"
	if minlvl==-1 then minlvl=SKULL end
	if maxlvl==-1 then maxlvl=SKULL end
	local level=minlvl.."-"..maxlvl
	if minlvl==maxlvl or info.player then level=maxlvl end
	local infotext=" ("..level..")"
	info.sex=mod.emotor:GetSex(name,target)
	if db.itsmemyself then infotext=", "..L.word.SEX[info.sex or 0]..","..infotext end
	if info.player then 
		infotext=name..", "..(info.guild or L.msg.noguild)..", "..(L.race[info.race] or info.race)..", "..(L.class[info.class] or info.class)..infotext
		if info.classified and info.classified[PLAYERNAME] then infotext=infotext.."\n"..(L.classify[info.classified[PLAYERNAME]] or info.classified[PLAYERNAME]) end
	else 
		infotext=name..", "..(info.race or info.family or "?")..", "..(L.class[info.class] or info.class or "?")..infotext
		if info.rare then infotext=infotext.." "..info.rare end
	end
	local usemet=PLAYERNAME
	if not met[PLAYERNAME].first.pos then usemet="others" end
	if met[usemet].first.pos then infotext=infotext.."\n"..Me:Meetinfo(met[usemet].first.time,met[usemet].first.pos,met[usemet].first.who) end
	if met[usemet].last.pos and met[usemet].last.time~=met[usemet].first.time then infotext=infotext.."\n"..Me:Meetinfo(met[usemet].last.time,met[usemet].last.pos,met[usemet].last.who) end
	if info.comment then infotext=infotext.."\n"..info.comment end
	if nr and of then infotext=nr.."/"..of.." "..infotext end
	widget.info:SetText(infotext)
	widget.info.showtime=0
	widget.locatebutton:Show()
	widget.commentbutton:Show()
	widget.commentbutton:SetText("@")
	widget.commentbutton.tooltipText=L.msg.ttcomment
	if not info.player then widget.palbutton:Hide()
	else
		widget.palbutton:Show()
		widget.palbutton.target=name
		local set={caption="T",tt=L.msg.PALUNKNOWN}
		if info.faction==FACTION then	
			if info.classified  and info.classified[PLAYERNAME] then 
				set={caption=string.sub(info.classified[PLAYERNAME],1,1) or set.caption,tt=L.msg["PAL"..(info.classified[PLAYERNAME] or "UNKNOWN")]}
			end
		else
			if not db.targets.list[name].kos or not db.targets.list[name].kos[FACTION] then set={caption="!",tt=L.msg.KOSUNKNOWN}
			elseif db.targets.list[name].kos[FACTION]=="KoS" then set={caption="KoS",tt=L.msg.KOSKOS} 
			else set={caption=":)",tt=L.msg.KOSFRIENDLY}
			end
		end
		widget.palbutton:SetText(set.caption)
		widget.palbutton.tooltipText=set.tt
		widget.palbutton.faction=info.faction
	end
	widget.locatebutton.target=name
	widget.commentbutton.target=name
end

function Me:Meetinfo(when,pos,who)
	local x,y,zone,zone_nr=mod.loc:ParseLoc(pos)
	local parsewho=mod.f:Split(who," ")
	if who==PLAYERNAME then who="" else who=" ("..parsewho[1]..")" end
	return date("%d.%m.%y, %H:%M:%S",when).." "..(zone or "nil").." ("..format("%.1f",x).."/"..format("%.1f",y)..")"..who
end

-- --------------------------------------------------------------------------------------
-- UNIT IN MY GUILD
-- --------------------------------------------------------------------------------------
function Me:UnitInMyGuild(who)
	local myguild,myrank,myindex=GetGuildInfo("player")
	local guild,rank,index=GetGuildInfo(who)
	return (guild and myguild==guild)
end

-- --------------------------------------------------------------------------------------
-- CLASSIFY
-- --------------------------------------------------------------------------------------
function Me:Classify(targetname)
	local class=nil
--	for p=1,5,1 do
--		if UnitExists("party"..p) and UnitName("party"..p)==targetname then class="KNOWN" end
--	end
	if db.targets.list[targetname] and db.targets.list[targetname].classified then
		class=db.targets.list[targetname].classified[PLAYERNAME] or class
	end
	return class
end

-- --------------------------------------------------------------------------------------
-- BUTTON SEARCH
-- --------------------------------------------------------------------------------------
function Me:ButtonSearch(button,parse)
	if button:GetText()=="X" then
		widget.searchinput:Hide()
		button.tooltipText=L.msg.ttsearch
		button:SetText("?")
		if widget.commentbutton:GetText()=="S" then
			widget.commentbutton:SetText("@")
			widget.commentbutton.tooltipText=L.msg.ttcomment
		else
			widget.searchup:Hide()
			widget.searchdown:Hide()
			widget.info.fixed=nil
		end
	else
		widget.searchinput:SetText("")
		widget.searchinput:Show()
		widget.searchinput.request="SEARCH"
		button:SetText("X")
		button.tooltipText=L.word.abort
	end
end

-- --------------------------------------------------------------------------------------
-- RUN SEARCH
-- --------------------------------------------------------------------------------------
function Me:InputSearch(keywidget,key)
	if key=="ENTER" or key=="ESCAPE" then 
		widget.searchinput:Hide() 
		widget.info.fixed=false
	end
	if key=="ENTER" and widget.searchinput.request=="COMMENT" then Me:StoreComment()
	elseif key=="ENTER" then -- REQUEST SEARCH 
		Me:RunSearch(widget.searchinput:GetText())
	end
end
function Me:RunSearch(command)
	if command and mod.f:Trim(command)~="" then
		local searches=mod.f:Split(string.upper(command)," ")
		local found={}
		local sort={}
		for name,info in pairs(db.targets.list) do
			local haystack=name.." "..(info.class or "").." "..(info.faction or "")..(info.guild or "").." "..(info.family or "")..(info.race or "").." "..(info.rare or "").." "..(info.comment or "")
			if info.classified and info.classified[PLAYERNAME] then haystack=haystack.." "..info.classified[PLAYERNAME] end
			for pos,whowhen in pairs(info.seen or {}) do
				local x,y,zone,znr=mod.loc:ParseLoc(pos)
				if zone and not string.find(haystack,zone) then haystack=haystack.." "..zone end
			end
			local matching=true
			for nr,search in pairs(searches) do
				if (search=="PLAYER" and info.player) or (search=="KOS" and info.kos and info.kos[FACTION]=="KoS") or (search=="KILLEDBY" and info.pvpkills>0) or string.find(string.upper(haystack),search) then 
					dummy=nil 
				else 
					matching=false 
				end
			end
			if matching then
				local lastseen=0
				for pos,whowhen in pairs(info.seen) do
					for playerchar,timeseen in pairs(whowhen) do lastseen=math.max(lastseen,timeseen) end
				end
				while found[lastseen] do lastseen=lastseen+0.001 end
				sort[1+#sort]=lastseen
				found[lastseen]=name
			end
		end
		if #sort==0 then 
			widget.info:SetText(mod.f:Color(mod.f:Repl(L.msg.notfound,{search=string.upper(command)}),"ff0000"))
			widget.info.fixed=nil
			widget.info.showtime=5
			widget.info:Show()
		else
			table.sort(sort)
			searchresult={sort=sort,name=found,max=#sort}
			Me:ShowSearch(#sort)
		end
	end
end

-- --------------------------------------------------------------------------------------
-- BUTTONS
-- --------------------------------------------------------------------------------------
function Me:Click(button,parse,leftright)
	if not widget.maint then
		widget.maint=mod.ui:newFrame(myname.."_Maint",250,110,Minimap,"TOPLEFT","TOPRIGHT",-20,-50,{})
		widget.maintclose=mod.ui:newButton(myname.."_Maint_Close",20,16,widget.maint,"TOPRIGHT","TOPRIGHT",-4,-4,{text="X",click=Me.MaintClose})
		widget.mainttitle=mod.ui:addText(myname.."_Maint_Title",250,100,widget.maint,"TOP","TOP",0,-4,11,"CENTER","TOP")
		widget.maintuntarget=mod.ui:newButton(myname.."_Maint_Untarget",230,19,widget.maint,"BOTTOMLEFT","BOTTOMLEFT",10,44,{text=L.word.untarget,tt=L.msg.untargettt,click=Me.MaintUntarget})
		widget.maintfliptarget=mod.ui:newButton(myname.."_Maint_Fliptarget",230,19,widget.maint,"BOTTOMLEFT","BOTTOMLEFT",10,24,{text=L.word.fliptarget,tt=L.msg.fliptargettt,click=Me.MaintFliptarget})
		widget.maintdeltarget=mod.ui:newButton(myname.."_Maint_Deltarget",230,19,widget.maint,"BOTTOMLEFT","BOTTOMLEFT",10,4,{text=L.word.delete,tt=L.msg.deltargettt,click=Me.MaintDeltarget})
	end
	widget.mainttitle:SetText(dbpc.target[button.id].text)
	widget.maint.id=button.id
	if leftright=="RightButton" then 
		Me:MaintUntarget()
	else
		widget.maint:Show()
	end
end

function Me:MaintUntarget(button,parse)
	Me:SetTarget(nil)
	Me:MaintClose()
end
function Me:MaintDeltarget(button,parse)
	local delpos=dbpc.target[widget.maint.id].pos
	db.targets.list[dbpc.name].seen[delpos]=nil
	Me:SetTarget(dbpc.name)
	Me:MaintClose()
end
function Me:MaintFliptarget(button,parse)
	if dbpc.only then
		dbpc.only=nil
		mod.loc:SetZoneList("targets",dbpc.target)
	else
		mod.loc:SetZoneList("targets",{dbpc.target[widget.maint.id]})
		dbpc.only=widget.maint.id
	end
	Me:MaintClose()
end

function Me:MaintClose() widget.maint:Hide() end

function Me:ButtonLocate(button,parse) Me:SetTarget(button.target) end

-- --------------------------------------------------------------------------------------
-- SET TARGET
-- --------------------------------------------------------------------------------------
function Me:SetTarget(name,mode)	
	if not name then 
		mod.loc:SetZoneList("targets",nil)
		dbpc.target=nil
	elseif name==dbpc.name and dbpc.target and mode=="init" then
		for t=1,#dbpc.target,1 do
			dbpc.target[t].click=Me.Click
		end
		if dbpc.only then 
			mod.loc:SetZoneList("targets",{dbpc.target[dbpc.only]})
		else
			mod.loc:SetZoneList("targets",dbpc.target)
		end
	else
		local keep=nil
		if mode=="keep" and dbpc.only then
			keep=dbpc.target[dbpc.only].pos
		end
		local myx,myy,myzone,mypos,myznr=mod.loc:GetLoc()
		dbpc.target={}
		dbpc.only=nil
		for pos,whowhen in pairs(db.targets.list[name].seen) do
			local distance=mod.loc:Distance(mypos,pos)
			local tx,ty,tzone,tznr=mod.loc:ParseLoc(pos)
			local mt=1+#dbpc.target
			dbpc.target[mt]={pos=pos,text=name.."\n"..tzone.." ("..tx.."/"..ty..")"..Me:LastSeen(whowhen),mindist=0,maxdist=9999999,icon=nil,click=Me.Click,id=mt}
			if keep==pos then 
				dbpc.only=mt 
			end
		end
		if dbpc.only then 
			mod.loc:SetZoneList("targets",{dbpc.target[dbpc.only]})
		else
			mod.loc:SetZoneList("targets",dbpc.target)
		end
	end
	dbpc.name=name
end


-- --------------------------------------------------------------------------------------
-- MAP CHANGED
-- --------------------------------------------------------------------------------------
function Me:MapChanged(zone,zone_nr)
	local name=dbpc.name
	local list={}
	if name and db.targets.list[name] then
		for pos,whowhen in pairs(db.targets.list[name].seen) do
			local tx,ty,tzone,tznr=mod.loc:ParseLoc(pos)
			if zone_nr==tznr then
				list[1+#list]={category=name,pos=pos,icon=nil,click=Me.Click,text=name..Me:LastSeen(whowhen)}
			end
		end
	end
	return list
end

-- --------------------------------------------------------------------------------------
-- LAST SEEN
-- --------------------------------------------------------------------------------------
function Me:LastSeen(whowhen)
	local lastseen=0
	local by=""
	for playerchar,timeseen in pairs(whowhen or {}) do 
		if lastseen<timeseen then
			lastseen=timeseen
			by=playerchar
		end
	end
	if lastseen==0 then return "" else return "\n"..date("%d.%m.%y, %H:%M:%S",lastseen).." "..by end
end

-- --------------------------------------------------------------------------------------
-- BUTTON PAL
-- --------------------------------------------------------------------------------------
function Me:ButtonPal(button,parse)
	local name=button.target
	local pal=button:GetText()
	local set={}
	if button.faction==FACTION then
		if pal=="T" then pal="KNOWN"
		elseif pal=="K" then pal="PAL"
		else pal=nil
		end
		if not db.targets.list[name].classified then db.targets.list[name].classified={} end
		db.targets.list[name].classified[PLAYERNAME]=pal
		set={caption=string.sub(pal or "T",1,1),tt=L.msg["PAL"..(pal or "UNKNOWN")]}
	else
		if not db.targets.list[name].kos then db.targets.list[name].kos={} end
		if pal=="!" then set={caption="KoS",tt=L.msg.KOSKOS,kos="KoS"}
		elseif pal=="KoS" then set={caption=":)",tt=L.msg.KOSFRIENDLY,kos="FRIENDLY"}
		else set={caption="!",tt=L.msg.KOSUNKNOWN,kos=nil}
		end
		db.targets.list[name].kos[FACTION]=set.kos
	end
	button:SetText(set.caption)
	button.tooltipText=set.tt
	if searchresult then Me:ShowSearch(searchresult.show) end
end
-- --------------------------------------------------------------------------------------
-- BUTTON COMMENT
-- --------------------------------------------------------------------------------------
function Me:ButtonComment(button,parse)
	if button:GetText()=="S" then
		Me:StoreComment()
		button:SetText("@")
		button.tooltipText=L.msg.ttcomment
	else
		local name=widget.commentbutton.target
		widget.searchinput:SetText(db.targets.list[name].comment or "")
		widget.searchinput:Show()
		widget.searchinput.request="COMMENT"
		button:SetText("S")
		button.tooltipText=L.msg.savecomment
		widget.searchbutton:SetText("X")
		widget.searchbutton.tooltipText=L.word.abort
		widget.info.fixed=true
	end
end

function Me:StoreComment()
	local comment=widget.searchinput:GetText()
	if comment=="" then comment=nil end
	local name=widget.commentbutton.target
	db.targets.list[name].comment=comment
	widget.commentbutton:SetText("@")
	widget.info.fixed=nil
	widget.searchinput:Hide() 
	if searchresult and searchresult.show then Me:ShowSearch(searchresult.show) else Me:PLAYER_TARGET_CHANGED() end
end

-- --------------------------------------------------------------------------------------
-- IDENTIFY CONFIG FRAMES
-- --------------------------------------------------------------------------------------
function Me:IdentifyConfigs() return {[1]=L.config.targets} end

-- --------------------------------------------------------------------------------------
-- START CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	config={changed=false}
	if not widget.config then
		widget.config={}
		widget.config.active=mod.ui:newCheck(myname.."_active",20,20,frame,"TOPLEFT","TOPLEFT",20,-10,{text=L.config.targets.." "..L.word.active,check=db.targets.active,click=Me.ConfigChange})
		widget.config.kos=mod.ui:newCheck(myname.."_kos",20,20,frame,"TOPLEFT","TOPLEFT",20,-30,{text=L.word.kos,check=db.targets.kos,click=Me.ConfigChange})
	else
		widget.config.active:SetChecked(db.targets.active)
		widget.config.kos:SetChecked(db.targets.kos)
	end
end

-- --------------------------------------------------------------------------------------
-- CONFIG CHECK FOR CHANGES
-- --------------------------------------------------------------------------------------
function Me:ConfigChange(button,parse)
	config.changed=(widget.config.active:GetChecked()~=db.targets.active)
	config.changed=config.changed or (widget.config.kos:GetChecked()~=db.targets.kos)
	mod.core:SetUnsavedChanges(config.changed)
end

-- --------------------------------------------------------------------------------------
-- SAVE CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	db.targets.active=widget.config.active:GetChecked()
	db.targets.kos=widget.config.kos:GetChecked()
	config.changed=false
	Me:Activate(db.targets.active)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) 
	Me:StartConfig(frame)
	return true 
end